<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/sys/dataDictionary">字典管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form ref="queryForm" :model="queryModel" inline class="demo-form-inline">
      <el-form-item label="名称" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
      </el-form-item>
      <el-form-item label="所属目录" prop="parentId">
        <el-select
            size="mini"
            v-model="queryModel.parentId"
            filterable
            remote
            placeholder="请输入关键词"
            :remote-method="queryMenu"
          >
            <el-option
              v-for="item in queryMenuResult"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
        >查询</el-button>&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
        >重置</el-button>&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button type="primary" size="small" plain icon="el-icon-circle-plus" @click="handleAdd">新增</el-button>
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-remove"
        :disabled="multipleSelection.length==0"
        @click="handleBatchDelete"
      >删除选中项</el-button>
    </el-row>
    <el-table
      :data="tableData"
      style="min-height:400px;"
      v-loading="loading"
      stripe
      border
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column
        prop="dataType"
        sort-by="data_type"
        label="类型"
        sortable="custom"
        width="180"
      >
       <template slot-scope="{row}">
         <span v-if="row.dataType=='1'">字典目录</span>
         <span v-else>数据</span>
       </template>
      </el-table-column>      
      <el-table-column
        prop="parentName"
        sort-by="parent_name"
        label="所属目录"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column prop="name" sort-by="name_" label="名称" sortable="custom" width="180"></el-table-column>
      <el-table-column prop="value" sort-by="value_" label="数值" sortable="custom" width="180"></el-table-column>
      <el-table-column prop="sortNo" sort-by="sort_no" label="排序号" sortable="custom"></el-table-column>
      <el-table-column label="操作" fixed="right" width="200">
        <template slot-scope="{row}">
          <el-row v-if="row.dataType=='1'">
            <el-col :span="12">
              <el-button size="mini" type="text" @click="showData(row)">查看数据</el-button>
            </el-col>
            <el-col :span="12">
              <el-button size="mini" type="text" @click="addData(row)">新增数据</el-button>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-button size="mini" type="text" @click="handleEdit(row)">编辑</el-button>
            </el-col>
            <el-col :span="12">
              <el-button size="mini" type="text" @click="handleDelete(row)">删除</el-button>
            </el-col>
          </el-row>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <dataDictionary-detail
      v-if="showModal"
      :dictId="dictId"
      :catalog="catalog"
      :modalTitle="modalTitle"
      @close="onDetailModalClose"
    ></dataDictionary-detail>
  </div>
</template>
<script>
import Constant from "@/constant";
import DataDictionaryDetail from "./dataDictionary-detail";
import dataDictionaryApi from "@/api/sys/dataDictionary";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style

export default {
  name: 'SysDataDictionaryList',
  data() {
    var self = this;

    return {
      queryModel: {
        id: "",
        name: "",
        value: "",
        sortNo: "",
        parentId: "",
        parentName: "",
        dataType: "",
        createBy: "",
        createDate: "",
        updateBy: "",
        updateDate: "",
        activated: ""
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      modalTitle: "",
      businessKey: "",
      queryMenuResult: []
    };
  },
  methods: {
    queryMenu(keywords) {
      var formData = new FormData();
      formData.append("keywords", keywords);
      formData.append("dataType", "1");
      formData.append("limit", 10);

      return dataDictionaryApi.query(formData).then(response => {
        var jsonData = response.data;

        if (jsonData.result) {
          this.queryMenuResult = jsonData.data;
        } else {
          this.$message.error(jsonData.message + "");
        }
      });
    },
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);
      formData.append("name", self.queryModel.name);
      formData.append("parentId", self.queryModel.parentId);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      dataDictionaryApi
        .pageList(formData)
        .then(function(response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch(error => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(()=>{
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order == "ascending" ? "asc" : "desc";

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
      this.queryMenu('');
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.dictId = "";
      this.catalog = {};
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.dictId = record.id;
      this.catalog = {};
      this.showModal = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
        .then(() => {
          dataDictionaryApi.remove(record.id).then(function(response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!"
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map(record => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        dataDictionaryApi.batchRemove(idList).then(function(response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!"
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;
      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
    addData(row) {
      this.modalTitle = "新增";
      this.dictId = "";
      this.catalog = row;
      this.showModal = true;
    },
    showData(row){
        this.queryMenuResult.length=0; //清空
        this.queryMenuResult.push(row);

        this.queryModel.parentId = row.id;
        this.queryModel.name = "";
        this.changePage(1);
    },
  },
  mounted: function() {
    this.changePage(1);
    this.queryMenu('');
  },
  components: {
    "dataDictionary-detail": DataDictionaryDetail
  }
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  padding: 10px;
  text-align: left;
}
</style>